import { Injectable } from '@nestjs/common';
import { GeoTimezoneFinder } from '../../../geography/adapters/secondaries/geo-timezone-finder';
import { IFindTimezone } from '../../../geography/domain/interfaces/timezone-finder.interface';

@Injectable()
export class TimezoneFinder implements IFindTimezone {
  constructor(private readonly geoTimezoneFinder: GeoTimezoneFinder) {}

  timezones = (lon: number, lat: number): string[] =>
    this.geoTimezoneFinder.timezones(lon, lat);
}
