import { Test, TestingModule } from '@nestjs/testing';
import { MatcherGeodesic } from '../../../../adapters/secondaries/geodesic';
import { Geodesic } from '../../../../../geography/adapters/secondaries/geodesic';

const mockGeodesic = {
  inverse: jest.fn().mockImplementation(() => ({
    azimuth: 45,
    distance: 50000,
  })),
};

describe('Matcher geodesic', () => {
  let matcherGeodesic: MatcherGeodesic;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [],
      providers: [
        MatcherGeodesic,
        {
          provide: Geodesic,
          useValue: mockGeodesic,
        },
      ],
    }).compile();

    matcherGeodesic = module.get<MatcherGeodesic>(MatcherGeodesic);
  });

  it('should be defined', () => {
    expect(matcherGeodesic).toBeDefined();
  });
  it('should get inverse values', () => {
    const inv = matcherGeodesic.inverse(0, 0, 1, 1);
    expect(Math.round(inv.azimuth)).toBe(45);
    expect(Math.round(inv.distance)).toBe(50000);
  });
});
